/**
 ******************************************************************************
 * @file           : main.c
 * @author         : Auto-generated by STM32CubeIDE
 * @brief          : Main program body
 ******************************************************************************
 * @attention
 *
 * Copyright (c) 2022 STMicroelectronics.
 * All rights reserved.
 *
 * This software is licensed under terms that can be found in the LICENSE file
 * in the root directory of this software component.
 * If no LICENSE file comes with this software, it is provided AS-IS.
 *
 ******************************************************************************
 */

#include <stdint.h>
#include <stdio.h>
#include <SEGGER_RTT.h>

#if !defined(__SOFT_FP__) && defined(__ARM_FP)
  #warning "FPU is not initialized, but the project is compiling for an FPU. Please initialize the FPU before use."
#endif

#if 1
/* add channel 1: log */
static uint8_t logBuffer[32];

char counter = 0;

int main(void)
{
  SEGGER_RTT_Init();

  /* add channel 1: log */
  SEGGER_RTT_ConfigUpBuffer(1, "Log", logBuffer, sizeof(logBuffer), SEGGER_RTT_MODE_NO_BLOCK_TRIM);

  while(1) {
    // Channel 0 - virtual terminal 0
    SEGGER_RTT_printf(0, "[0:0] counter = %d\n", counter++);

    // switch to Channel 0 - virtual terminal 1
    SEGGER_RTT_SetTerminal(1);

    SEGGER_RTT_printf(0, "[0:1] negative = %d\n", -counter);

    // back to Channel 0 - virtual terminal 0
    SEGGER_RTT_SetTerminal(0);

    // print to Channel 0 - virtual terminal 2
    SEGGER_RTT_TerminalOut(2, "[0:2] nothing\n");

    // print to Channel 1
    SEGGER_RTT_printf(1, "[1:x] last_digit = %d\n", counter%2);

    for(int delay=160000; delay--;);
  }
}

#else

int main(void)
{
  SEGGER_RTT_Init();
  printf("Enter a number: ");

  int a;
  scanf("%d", &a);

  printf("Thanks! I got %d\n", a);
}
#endif
